package cn.tonyandmoney.tuon.core.cros;

import cn.tonyandmoney.tuon.core.utils.CrosUtils;
import org.springframework.core.Ordered;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.web.filter.OncePerRequestFilter;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 跨域设置
 */
public class GlobalWebCrosFilter extends OncePerRequestFilter implements Ordered {
    @Override
    protected void doFilterInternal(HttpServletRequest request,
                                    HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException {

        CrosUtils.allow(request, response);
        if (request.getMethod().equals(HttpMethod.OPTIONS.name())) {
            response.setStatus(HttpStatus.OK.value());
            response.flushBuffer();
        } else {
            filterChain.doFilter(request, response);
        }
    }

    @Override
    public int getOrder() {
        return -2;
    }
}
